"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.convertToQuery = exports.convertToDocumentSnap = exports.convertToQuerySnap = exports.convertToDocumentRef = exports.convertToCollectionRef = exports.QueryProperties = exports.DocumentSnapProperties = exports.QuerySnapProperties = exports.DocumentRefProperties = exports.CollectionRefProperties = void 0;

var _identity = _interopRequireDefault(require("lodash/fp/identity"));

var _constant = _interopRequireDefault(require("lodash/fp/constant"));

var _assign = _interopRequireDefault(require("lodash/assign"));

var _createConverterOfType = _interopRequireDefault(require("./createConverterOfType"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const CollectionRefProperties = {};
exports.CollectionRefProperties = CollectionRefProperties;
const DocumentRefProperties = {};
exports.DocumentRefProperties = DocumentRefProperties;
const QuerySnapProperties = {};
exports.QuerySnapProperties = QuerySnapProperties;
const DocumentSnapProperties = {};
exports.DocumentSnapProperties = DocumentSnapProperties;
const QueryProperties = {};
exports.QueryProperties = QueryProperties;
(0, _assign.default)(CollectionRefProperties, {
  id: _identity.default,
  // parent: toDocumentRef // defined below due to reference loop
  doc: _identity.default,
  get: _identity.default,
  path: _identity.default,
  where: _identity.default,
  __exists: _identity.default,
  __converterType: (0, _constant.default)('collection ref')
});
const convertToCollectionRef = (0, _createConverterOfType.default)(CollectionRefProperties);
exports.convertToCollectionRef = convertToCollectionRef;
(0, _assign.default)(DocumentRefProperties, {
  id: _identity.default,
  // parent: toCollectionRef // defined below due to reference loop
  get: _identity.default,
  collection: _identity.default,
  path: _identity.default,
  set: _identity.default,
  update: _identity.default,
  __exists: _identity.default,
  __converterType: (0, _constant.default)('document ref')
});
const convertToDocumentRef = (0, _createConverterOfType.default)(DocumentRefProperties);
exports.convertToDocumentRef = convertToDocumentRef;
(0, _assign.default)(QuerySnapProperties, {
  docs: _identity.default,
  empty: _identity.default,
  size: _identity.default,
  __exists: _identity.default,
  __converterType: (0, _constant.default)('query snap')
});
const convertToQuerySnap = (0, _createConverterOfType.default)(QuerySnapProperties);
exports.convertToQuerySnap = convertToQuerySnap;
(0, _assign.default)(DocumentSnapProperties, {
  id: _identity.default,
  ref: _identity.default,
  data: _identity.default,
  exists: _identity.default,
  __exists: _identity.default,
  __converterType: (0, _constant.default)('document snap')
});
const convertToDocumentSnap = (0, _createConverterOfType.default)(DocumentSnapProperties);
exports.convertToDocumentSnap = convertToDocumentSnap;
(0, _assign.default)(QueryProperties, {
  where: _identity.default,
  get: _identity.default,
  __converterType: (0, _constant.default)('query')
});
const convertToQuery = (0, _createConverterOfType.default)(QueryProperties);
exports.convertToQuery = convertToQuery;
DocumentRefProperties.parent = convertToCollectionRef;
CollectionRefProperties.parent = convertToDocumentRef;