"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _mapValues = _interopRequireDefault(require("lodash/fp/mapValues"));

var _assign = _interopRequireDefault(require("lodash/assign"));

var _getAndConvertChild = _interopRequireDefault(require("../getAndConvertChild"));

var _converters = require("../../converters");

var _exists = _interopRequireDefault(require("./exists"));

var _size = _interopRequireDefault(require("./size"));

var _empty = _interopRequireDefault(require("./empty"));

var _docs = _interopRequireDefault(require("./docs"));

var _ref = _interopRequireDefault(require("./ref"));

var _data = _interopRequireDefault(require("./data"));

var _get = _interopRequireDefault(require("./get"));

var _set = _interopRequireDefault(require("./set"));

var _update = _interopRequireDefault(require("./update"));

var _where = _interopRequireDefault(require("./where/where"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Props
const augmentProps = mockDocument => {
  const bindToMockDocument = it => it(mockDocument);

  Object.defineProperties(mockDocument, (0, _mapValues.default)(bindToMockDocument)({
    exists: _exists.default,
    size: _size.default,
    empty: _empty.default,
    docs: _docs.default,
    ref: _ref.default
  }));
};

const augmentMethods = (mockDocument, createMockFirestoreDocument) => (0, _assign.default)(mockDocument, {
  collection: (0, _getAndConvertChild.default)(_converters.convertToCollectionRef, mockDocument, createMockFirestoreDocument),
  data: (0, _data.default)(mockDocument),
  doc: (0, _getAndConvertChild.default)(_converters.convertToDocumentRef, mockDocument, createMockFirestoreDocument),
  get: (0, _get.default)(mockDocument, createMockFirestoreDocument),
  set: (0, _set.default)(mockDocument),
  update: (0, _update.default)(mockDocument),
  where: (0, _where.default)(mockDocument, createMockFirestoreDocument)
});

var _default = (mockDocument, createMockFirestoreDocument) => {
  augmentMethods(mockDocument, createMockFirestoreDocument);
  augmentProps(mockDocument);
};

exports.default = _default;